#include <cs50.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>


int main(int argc, string argv[])
{
    // Check if a key was entered
    if (argc != 2)
    {
        printf("Usage: ./substitution key\n");
        return 1;
    }

    string normalAlphabet = "abcdefghijklmnopqrstuvwxyz";
    string key = argv[1];
    int alpha_length = strlen(normalAlphabet);
    int key_length = strlen(argv[1]);
    int letter_counter;

    int check_26chars = 0;
    int check_duplicates = 0;

    // Check if key is 26 characters long
    if (strlen(argv[1]) == 26)
    {
        check_26chars = 1;
    }
    else
    {
        printf("Error: key must contain 26 characters.\n");
        return 1;
    }

    // Loop through alphabet
    for (int i = 0; i < alpha_length; i++)
    {
        letter_counter = 0;

        for (int j = 0; j < key_length; j++)
        {
            if (normalAlphabet[i] == tolower(key[j]))
            {
                letter_counter++;
            }
        }

        // After going through each character of the key for one letter of the alphabet, the counter of matches should be 1
        if (letter_counter == 1)
        {
            check_duplicates = 1;
        }
        else
        {
            printf("Error: Key contains duplicates.\n");
            return 1;
        }
    }


    string plaintext = get_string("plaintext:");
    int plaintext_length = strlen(plaintext);

    printf("ciphertext: ");
    // Loop through plaintext
    for (int k = 0; k < plaintext_length; k++)
    {
        if (isalpha(plaintext[k]))
        {
            // Check if plaintext is lowercase and if so use standard alphabet/key
            // != 0 means it IS lowercase
            if (islower(plaintext[k]) != 0)
            {
                // Loop through the alphabet to find the letter of the plaintext
                for (int m = 0; m < alpha_length; m++)
                {
                    if (plaintext[k] == normalAlphabet[m])
                    {
                        // Print encrypted character
                        printf("%c", tolower(key[m]));
                    }
                }
            }
            else if (isupper(plaintext[k]) != 0)
            {
                // Loop through the alphabet to find the letter of the plaintext
                for (int m = 0; m < alpha_length; m++)
                {
                    if (tolower(plaintext[k]) == normalAlphabet[m])
                    {
                        // Print encrypted character
                        printf("%c", toupper(key[m]));
                    }
                }
            }
        }
        else
        {
            // Print all other characters as they are
            printf("%c", plaintext[k]);
        }
    }
    // New line at the end to finish off
    printf("\n");
    return 0;
}